# IExMovie Struct Reference
[External Interfaces]

Inheritance diagram for IExMovie:

List of all members.

## Public Member Functions
virtual MCCOMErr MCCOMAPI | CreateMovieController (IMFPart **movieController)=0
virtual MCCOMErr MCCOMAPI | SelfStartPlaying (uint32 frameIndex)=0
virtual MCCOMErr MCCOMAPI | SelfStopPlaying (uint32 frameIndex)=0
virtual MCCOMErr MCCOMAPI | Initialize (const TMCString &fullPathName, const TSequencedMovieInfos *infos=NULL)=0
virtual MCCOMErr MCCOMAPI | BeginRead ()=0
virtual MCCOMErr MCCOMAPI | GetFrameRate (real32 &frameRate)=0
virtual MCCOMErr MCCOMAPI | GetFrameCount (uint32 &frameCount)=0
virtual MCCOMErr MCCOMAPI | GetFrame (IShRasterLayer **rasterLayer, uint32 frameIndex)=0
virtual MCCOMErr MCCOMAPI | GetFrame (IShLayerList **layerList, uint32 frameIndex, boolean forceLoad)=0
virtual MCCOMErr MCCOMAPI | EndRead ()=0
virtual boolean MCCOMAPI | HasOptionsDialog ()=0
virtual MCCOMErr MCCOMAPI | ShowOptionsDialog (uint32 depth, real32 &frameRate)=0
virtual MCCOMErr MCCOMAPI | BeginWrite (const TMCString &fullPathName, uint32 sizeH, uint32 sizeV, uint32 depth, real32 frameRate, boolean append)=0
virtual MCCOMErr MCCOMAPI | PutFrame (IShRasterLayer *rasterLayer, const TGBuffer32List *gBuffers, uint32 frameIndex)=0
virtual MCCOMErr MCCOMAPI | PutFrame (IShLayerList *layerList, const TGBuffer32List *gBuffers, uint32 frameIndex)=0
virtual MCCOMErr MCCOMAPI | PutSound (IExSound *inSound, uint32 startTime, int32 offsetInSound)=0
virtual MCCOMErr MCCOMAPI | Flush ()=0
virtual MCCOMErr MCCOMAPI | GetMovieFullPathName (TMCString &fullPathName)=0
virtual MCCOMErr MCCOMAPI | EndWrite ()=0
virtual MCCOMErr MCCOMAPI | PostWrite ()=0
virtual void MCCOMAPI | GetCapabilities (ImageExportCapabilities &capabitilities)=0
virtual MCCOMErr MCCOMAPI | CopySoundtrack (IExMovie **outMovie)=0
virtual MCCOMErr MCCOMAPI | MakeCopy (const TMCString &fullPathName, TMCString &outFirstFileName)=0
virtual MCCOMErr MCCOMAPI | DeleteMovie ()=0
virtual void MCCOMAPI | GetCompressionOptions (IExMovieCompressionOptions **movieOptions)=0
virtual void MCCOMAPI | SetCompressionOptions (IExMovieCompressionOptions *movieOptions)=0
virtual boolean MCCOMAPI | CanHaveSounds ()=0
virtual boolean MCCOMAPI | HasSounds ()=0
virtual MCCOMErr | FinishAddingSound ()=0

## Member Function Documentation

virtual MCCOMErr MCCOMAPI IExMovie::BeginRead | ( |  | ) | `[pure virtual]`

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::BeginWrite | ( | const TMCString & | fullPathName,
|  | uint32 | sizeH,
|  | uint32 | sizeV,
|  | uint32 | depth,
|  | real32 | frameRate,
|  | boolean | append |
| ) |  |  | `[pure virtual]`

Implemented in TBasicMovie.

virtual boolean MCCOMAPI IExMovie::CanHaveSounds | ( |  | ) | `[pure virtual]`

Returns true if the Movie format supports sounds.

virtual MCCOMErr MCCOMAPI IExMovie::CopySoundtrack | ( | IExMovie ** | outMovie | ) | `[pure virtual]`

Copies the soundtrack from the current movie to the movie at outMovie. Currently only implemented for Quicktime to Quicktime movie copies.

Parameters:

  | outMovie |

virtual MCCOMErr MCCOMAPI IExMovie::CreateMovieController | ( | IMFPart ** | movieController | ) | `[pure virtual]`

Creates a movie controller. Return MC_E_NOTIMPL and a standard movie controller will be provided.

Parameters:

  | movieController | A pointer to a movie controller part.

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::DeleteMovie | ( |  | ) | `[pure virtual]`

Deletes the movie

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::EndRead | ( |  | ) | `[pure virtual]`

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::EndWrite | ( |  | ) | `[pure virtual]`

Implemented in TBasicMovie.

virtual MCCOMErr IExMovie::FinishAddingSound | ( |  | ) | `[pure virtual]`

Should be called after all the called to PutSound to get the changes written to disk.

virtual MCCOMErr MCCOMAPI IExMovie::Flush | ( |  | ) | `[pure virtual]`

Calling flush insures that the movie file is valid up to the last PutFrame.

Implemented in TBasicMovie.

virtual void MCCOMAPI IExMovie::GetCapabilities | ( | ImageExportCapabilities & | capabitilities | ) | `[pure virtual]`

Returns which buffers can be saved with this file format

Parameters:

  | capabitilities | Flags that are returned.

Implemented in TBasicMovie.

virtual void MCCOMAPI IExMovie::GetCompressionOptions | ( | IExMovieCompressionOptions ** | movieOptions | ) | `[pure virtual]`

Returns a pointer to the compression options used for this movie

Parameters:

  | movieOptions |

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::GetFrame | ( | IShLayerList ** | layerList,
|  | uint32 | frameIndex,
|  | boolean | forceLoad |
| ) |  |  | `[pure virtual]`

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::GetFrame | ( | IShRasterLayer ** | rasterLayer,
|  | uint32 | frameIndex |
| ) |  |  | `[pure virtual]`

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::GetFrameCount | ( | uint32 & | frameCount | ) | `[pure virtual]`

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::GetFrameRate | ( | real32 & | frameRate | ) | `[pure virtual]`

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::GetMovieFullPathName | ( | TMCString & | fullPathName | ) | `[pure virtual]`

Sometimes the file name can change between open and save. More specifically, when using numbered files. you save "Movie.jpg" but you reopen "Movie001.jpg" because this is the actual file. Return MC_E_NOTIMPL and the shell will provide a default implementation

Parameters:

  | fullPathName |

Implemented in TBasicMovie.

virtual boolean MCCOMAPI IExMovie::HasOptionsDialog | ( |  | ) | `[pure virtual]`

Implemented in TBasicMovie.

virtual boolean MCCOMAPI IExMovie::HasSounds | ( |  | ) | `[pure virtual]`

Returns true if the Movie has sounds in it

virtual MCCOMErr MCCOMAPI IExMovie::Initialize | ( | const TMCString & | fullPathName,
|  | const TSequencedMovieInfos * | infos = `NULL` |
| ) |  |  | `[pure virtual]`

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::MakeCopy | ( | const TMCString & | fullPathName,
|  | TMCString & | outFirstFileName |
| ) |  |  | `[pure virtual]`

Makes an exact copy of the movie to the location given by fullPathName. Returns the name of the first written file (equals fullPathName if non sequenced) Return MC_E_NOTIMPL and the shell will provide a default implementation.

Parameters:

  | fullPathName |
  | outFirstFileName |

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::PostWrite | ( |  | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IExMovie::PutFrame | ( | IShLayerList * | layerList,
|  | const TGBuffer32List * | gBuffers,
|  | uint32 | frameIndex |
| ) |  |  | `[pure virtual]`

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::PutFrame | ( | IShRasterLayer * | rasterLayer,
|  | const TGBuffer32List * | gBuffers,
|  | uint32 | frameIndex |
| ) |  |  | `[pure virtual]`

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::PutSound | ( | IExSound * | inSound,
|  | uint32 | startTime,
|  | int32 | offsetInSound |
| ) |  |  | `[pure virtual]`

Adds a sound to the movie. Don't forget to call FinishAddingSound once you are done adding all the sounds.

Parameters:

  | inSound | The sound that should be added to the movie.
  | startTime | Start time of the sound in the animation
  | offsetInSound | Offset into the sound where it actually starts

virtual MCCOMErr MCCOMAPI IExMovie::SelfStartPlaying | ( | uint32 | frameIndex | ) | `[pure virtual]`

Called only when the standard movie controller is used

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::SelfStopPlaying | ( | uint32 | frameIndex | ) | `[pure virtual]`

Called only when the standard movie controller is used

Implemented in TBasicMovie.

virtual void MCCOMAPI IExMovie::SetCompressionOptions | ( | IExMovieCompressionOptions * | movieOptions | ) | `[pure virtual]`

Sets the compression options used for this movie

Implemented in TBasicMovie.

virtual MCCOMErr MCCOMAPI IExMovie::ShowOptionsDialog | ( | uint32 | depth,
|  | real32 & | frameRate |
| ) |  |  | `[pure virtual]`

Implemented in TBasicMovie.

The documentation for this struct was generated from the following file:

- IExMovie.h